################################################################################################
# This perl script parses information files gathered about the usage of Rational FLEXLM        #
# licenses and outputs a summary line to a cumulative log file.                                #
# For the week number to be correct the run number and the week number must be set in the      #
# relevant files (week.no and run.no). run.no is the number of times the file is run in a week.#
################################################################################################
###########################################
# Use the Code below for Summer Time time.#
###########################################
#@DateTime = gmtime(time);
#$seconds=time;
#$date= $DateTime[3]."/".($DateTime[4] + 1)."/".($DateTime[5] + 1900);
#$time= (@DateTime[2] + 1).":".@DateTime[1].":".@DateTime[0];
#$index= @DateTime[6];
#@weekday = qw ( Monday Tuesday Wednesday Thursday Friday Saturday Sunday );
#$weekday = @weekday[$index-1];
#$datetime = @DateTime[3]."/".(@DateTime[4] + 1)."/".(@DateTime[5] + 1900)." ".(@DateTime[2] + 1).":".@DateTime[1].":".@DateTime[0];
###########################################
# Use the Code below for Winter Time time.#
###########################################
@DateTime = gmtime(time);
$seconds=time;
$date= @DateTime[3]."/".(@DateTime[4] + 1)."/".(@DateTime[5] + 1900);
$time= (@DateTime[2]).":".@DateTime[1].":".@DateTime[0];
$index= @DateTime[6];
@weekday = qw ( Monday Tuesday Wednesday Thursday Friday Saturday Sunday );
$weekday = @weekday[$index-1];
$datetime = @DateTime[3]."/".(@DateTime[4] + 1)."/".(@DateTime[5] + 1900)." ".(@DateTime[2]).":".@DateTime[1].":".@DateTime[0];


open (RUNNO, "bobs\\run.no") || die $_;
foreach (<RUNNO>) {
			 $run = $_;
		}
close RUNNO;
open (WEEKNO, "bobs\\week.no") || die $_;
foreach (<WEEKNO>) {
			 $week = $_;
		}
close WEEKNO;

if ($run < 336) {
	$run++;
	}
	else {
		$run = 1;
		$week++;
		}

open (RUNNO, ">bobs\\run.no") || die $_;
print RUNNO $run;
close RUNNO;
open (WEEKNO, ">bobs\\week.no") || die $_;
print WEEKNO $week;
close WEEKNO;

sub get_count {
	open COUNT_FILE, $_[0];
	while (<COUNT_FILE>)
	{
		$line=$_;
		chomp($line);
 
		$cnt=index($line, ":");
		if ($cnt != -1)
		{
			close COUNT_FILE;
			return substr($line, $cnt+1,20);
		}
	}
}
sub get_denied {
	open count_file, $_[0];
	while (<count_file>)
	{
		$line=$_;
		chomp($line);

		$cnt=index($line, "license");

		if ($cnt != -1)
		{
			$cnt=index($line, " ");
			close count_file;
			return substr($line, 0,$cnt);
		}
	}
}
sub get_max {
	open count_file, $_[0];
	while (<count_file>)
	{
		$line=$_;
		chomp($line);
		$cnt=index($line, "Total of ");
		if ($cnt != -1)
		{
			close count_file;
			$tail=substr($line, $cnt+9, 100);
			$cnt=index($tail, " ");
			return substr($tail,0,index($tail, " "));
		}
	}
}


$anal=get_count("bobs\\anal.cnt");
$cq=get_count("bobs\\cq.cnt");
$rse=get_count("bobs\\rse.cnt");
$tststud=get_count("bobs\\tststud.cnt");
$analmax=get_max("bobs\\anal.max");
$cqmax=get_max("bobs\\cq.max");
$rsemax=get_max("bobs\\rse.max");
$tststudmax=get_max("bobs\\tststud.max");
$ccmax=get_count("bobs\\ccmax.cnt");
$msmax=get_count("bobs\\msmax.cnt");
$cccur=get_count("bobs\\cccur.cnt");
$mscur=get_count("bobs\\mscur.cnt");
$ccden=get_denied("bobs\\ccdenied.cnt");
$msden=get_denied("bobs\\msdenied.cnt");
$suitetotal = ($anal + $rse);
$rose=get_count("bobs\\rose.cnt");
$rosemax=get_max("bobs\\rose.max");

open ( lic_dat, ">>license_history.csv");
print lic_dat 
	  $datetime		,",",   #Date + time in excell format
	  $suitetotal   ,",",	#Total Suite licenses (analysis + enterprise)
      $tststud 		,",",	# no of test studio licenses in use
	  $rose			,",",   # No of Rose Enterpeise
      $cq 		    ,",",	# No of ClearQuest Licenses inuse
      $cccur		,",",	# No of ClearCase license in use
      $mscur 		,",",   # No of MultiSite Licenses in use
      $anal    		,",",	# No. of analyst studio licenses in use
      $rse     		,",",	# no. of Suite enterprise licenses in use
      $analmax 		,",",	# Max no. of analyst studio licenses
      $rsemax  		,",",	# max suite licenses available
	  $rosemax		,",",	# max Rose Licenses available
      $tststudmax	,",",	# max no. of test studio licenses available
      $cqmax		,",",
      $ccmax 		,",", 
      $msmax		,",",       
      $ccden		,",", 
      $msden        ,",",
      $weekday      ,",",
	  $seconds      ,",",
	  $week;
print lic_dat "\n";
close lic_dat;